package lesson06;

import javax.swing.JOptionPane;

public class Factorial {
	public static void main(String[] args) {
		new Factorial().start();
	}
	
	/* 問題①　*/
	void start(){
		String input = JOptionPane.showInputDialog("nの階乗を求めます。nの値を入力してください");
		int n = Integer.parseInt(input);
		int result = fact(n);
		JOptionPane.showMessageDialog(null, n + " の階乗は " + result + " です");
	}
	/** 再帰関数　仮引数nが0じゃないならn-1を実引数としてもう一個fact()を呼び出す **/
	int fact(int n){
		/* n == 0じゃない場合場合はそのまま下に行き，
		 * また(n-1)の階乗を求めることになる．
		 * n == 0のときに1を返せば
		 * 最終的に返す数字は「(nの階乗)×1」になり，結果「nの階乗になる」
		 */
		if(n == 0){
			return 1;
		}
		/* n * ((n-1) の階乗)を返す (n-1)の階乗を求めるのにもう1個fact()を呼ぶ
		 * (n-1)の階乗は (n-1) * (n-2)の階乗…
		 */
		return n * fact(n - 1);
	}
}
