package lesson06;

import javax.swing.JOptionPane;

public class HitAndBlow {
	public static void main(String[] args) {
		new HitAndBlow().start();
	}
	
	void start() {
		//正解保存用配列
		int[] corrects = new int[3];
		
		while(true){
			//全部バラバラの数字になるまでランダムで3つの数を決める
			int number1 = (int)(Math.random()*5+1);
			int number2 = (int)(Math.random()*5+1);
			int number3 = (int)(Math.random()*5+1);
			if(number1 != number2 && number2 != number3 && number3 != number1){
				corrects[0] = number1;
				corrects[1] = number2;
				corrects[2] = number3;
				break;
			}
		}
		// 数字と場所が合っている数
		int hit = 0;
		// 数字だけ合っている数
		int blow = 0;
		//解答保存用配列
		int[] answers = {0, 0, 0};
		//入力用変数
		String input = "";
		/** メインループ **/
		while(true){
			String header = "入力した数字:" + input + "\n" + 
							"数字と場所が合っている：" + hit + "\n" +
							"数字だけ合っている：" + blow + "\n" +
							"[1~5]を使い3つの数字をカンマ区切りで入力してください";
			input = JOptionPane.showInputDialog(header);

			//hitとblowを初期化
			hit = 0;
			blow = 0;

			//入力した文字列を「,」で区切って配列に入れる
			String[] stringArray = input.split(",");
			//stringArrayの要素をint型にしてanswersに代入
			for(int i = 0; i < stringArray.length; i++){
				answers[i] = Integer.parseInt(stringArray[i]);
			}
			
			//入力した数字が全てバラバラか確認
			if(answers[0] == answers[1] || answers[0] == answers[2] || answers[1] == answers[2]){
				JOptionPane.showMessageDialog(null, "全て違う数字を入力してください");
				//countinue;を使うと,ループの最初に戻ります．この場合メインループの最初にもどります
				continue;
			}

			/*正解判定
			 *answers[]配列とcorrects[]配列を比べる
			 */
			for(int i = 0; i < answers.length; i++){
				for(int k = 0; k < corrects.length; k++){
					//場所と数字が一致の場合
					if(answers[i] == corrects[k] && i == k){
						hit++;
					}
					//数字だけ一致の場合
					else if(answers[i] == corrects[k]){
						blow++;
					}
				}
			}
			//入力した文字,hitの数，blowの数をコンソールに表示
			System.out.println(input + ": " + hit + ": " + blow);

			//全問正解なら終了
			if(hit == 3){
				JOptionPane.showMessageDialog(null, "全て合致しました！終了です！");
				break;
			}
		}
	}
}
